#include <Wire.h>
#include <stdint.h>
#include "Abfahrtsmonitor.h"


Abfahrtsmonitor::Abfahrtsmonitor(uint8_t rows) {

  _lcd = new LiquidCrystal_I2C(0x27, 20, 4);
  Zeilen = rows;
  return;
}


void Abfahrtsmonitor::init() {

  _lcd->init();
 
  _lcd->backlight();
  _lcd->setCursor(0, 1);
  _lcd->print("MVG Abfahrtsmonitor");
  _lcd->setCursor(0, 2);
  _lcd->print("Version 0.2");
 
  return;

}



void Abfahrtsmonitor::clear() {

 
  _lcd->clear();
 
  return;

}

String Abfahrtsmonitor::replaceUmlaute(String ziel) {

  ziel.replace("ä", "\341");
  ziel.replace("ö", "\357");
  ziel.replace("ü", "\365");
  ziel.replace("ß", "\342");
  return ziel;
}


void Abfahrtsmonitor::writeZeile(uint8_t row, String label, String destination, uint8_t departureTime ) {
  row = row - 1;
  zeilenspeicher[row].label =  label;
  zeilenspeicher[row].destination =  replaceUmlaute(destination);
  zeilenspeicher[row].pos =  1;
  zeilenspeicher[row].departureTime =  departureTime;

  return;
}


String Abfahrtsmonitor::fuellen(String Text, uint8_t laenge, bool dir) {

  uint8_t aktlaenge = Text.length();

  for (int i = aktlaenge; i < laenge; i++) {
    if (dir) {
      Text = Text + " ";
    }
    else {
      Text = " " + Text;
    }
  }
  return Text; 
}



String Abfahrtsmonitor::Lauftext(String Text , uint8_t *pos, uint8_t laenge, bool lauftextein ) {

  uint8_t aktlaenge = Text.length();

  if (aktlaenge >= laenge & !lauftextein ) {

    if (((*pos) + laenge) < aktlaenge ) {

      Text = Text.substring(*pos, (*pos + laenge));

      (*pos)++;
    }
    else {

      Text = Text.substring(*pos, aktlaenge) + " " + Text.substring(0, (laenge  - (aktlaenge - *pos)));
      Text = Text.substring(0, laenge);

      if ((*pos) < aktlaenge) {
        (*pos)++;
      }
      else {
        (*pos) = 1;
      }
    }
  }

  else {
    Text =  fuellen(Text, laenge, true);
  }
  return Text;
}


void Abfahrtsmonitor::LCDrefresh() {

    for (int i; i < Zeilen; i++) {
      _lcd->setCursor(0, i);
      _lcd->print(fuellen(zeilenspeicher[i].label, 3, true));
      _lcd->setCursor(4, i);
      _lcd->print(Lauftext(zeilenspeicher[i].destination, &zeilenspeicher[i].pos , 14, true));
      _lcd->setCursor(17, i);
      _lcd->print(fuellen(String(zeilenspeicher[i].departureTime), 3, false));
    }
  
  return;
}





