
//////////////////////////////////////////////////////////////////////////
////////////////////Einfügen der Bibliotheken/////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <ArduinoJson.h>
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <TimeLib.h>
#include <NTPClient.h>
#include <WiFiUdp.h>

#include "Abfahrtsmonitor.h"
#include <Ticker.h>

Ticker flipper;



//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

WiFiUDP ntpUDP;


NTPClient timeClient(ntpUDP, "ptbtime1.ptb.de");

Abfahrtsmonitor abfahrtsmonitor(4);


//////////////////////////////////////////////////////////////////////////
//////////////////////Definieren der Konstanten///////////////////////////
//////////////////////////////////////////////////////////////////////////


const char* ssidto = "Wlan1";
const char* pdto = "";


const char* ssid = "WLAN2";
const char* pd = "";

const char* ssidtest = "Wlan3";
const char* pdtest = "";



const char* host = "www.mvg.de";
const int httpsPort = 443;
//const size_t bufferSize = JSON_ARRAY_SIZE(12) + JSON_OBJECT_SIZE(1) + 12 * JSON_OBJECT_SIZE(8) + 1920;
//const size_t bufferSize = JSON_ARRAY_SIZE(12) + JSON_ARRAY_SIZE(50) + JSON_OBJECT_SIZE(2) + 12 * JSON_OBJECT_SIZE(6) + 50 * JSON_OBJECT_SIZE(8) + 5280;
const size_t bufferSize = JSON_ARRAY_SIZE(21) + JSON_ARRAY_SIZE(30) + JSON_OBJECT_SIZE(2) + 21 * JSON_OBJECT_SIZE(6) + 30 * JSON_OBJECT_SIZE(8) + 7100;

const char* fingerprint = "25 C2 12 76 34 3D 34 83 F9 0A 91 0D 45 3E D0 DF 25 45 7A 9E";
bool data = 0;




//////////////////////////////////////////////////////////////////////////
///////////////////Initialisierung bei Start//////////////////////////////
//////////////////////////////////////////////////////////////////////////



void setup() {


  Serial.begin(115200);
  abfahrtsmonitor.init();

  wifi();
  timeClient.begin();
  flipper.attach(0.71, flip);


}


void flip() {

  if (data != 0) {
    abfahrtsmonitor.LCDrefresh();
  }
}


void loop() {

  mvv();

  for (int i = 0; i <= 300; i++) {
    delay(100);
    yield();
  }

}


//////////////////////////////////////////////////////////////////////////
////////////////////////Verbindung mit dem WLAN///////////////////////////
//////////////////////////////////////////////////////////////////////////

void ScanResult() {

  int n = WiFi.scanNetworks();
  Serial.print(n);
  Serial.println(" network(s) found");

  for (int i = 0; i < n; i++)
  {
    Serial.println(WiFi.SSID(i));

    if (WiFi.SSID(i) == ssidto) {
      Serial.print("connecting to ");
      Serial.println(ssidto);
      WiFi.begin(ssidto, pdto);
      while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
      }
      break;
    }

    if (WiFi.SSID(i) == ssid) {
      Serial.print("connecting to ");
      Serial.println(ssid);
      WiFi.begin(ssid, pd);
      while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
      }
      break;
    }
    if (WiFi.SSID(i) == ssidtest) {
      Serial.print("connecting to ");
      Serial.println(ssidtest);
      WiFi.begin(ssidtest, pdtest);
      while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
      }
      break;
    }

  }



}

void wifi() {

  while (WiFi.status() != WL_CONNECTED) {

    ScanResult();

  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
}





//////////////////////////////////////////////////////////////////////////
/////////////////////////////Funktion MVV/////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void mvv() {

  wifi();

  WiFiClientSecure client;
  client.setTimeout(10000);
  if (!client.connect(host, httpsPort)) {
    Serial.println("connection failed");
    return;
  }

  if (client.verify(fingerprint, host)) {
    Serial.println("certificate matches");
  } else {
    Serial.println("certificate doesn't match");
  }


  String url = "/fahrinfo/api/departure/311?footway=0";


  client.print(String("GET ") + url + " HTTP/1.1\r\n" + "Host: " + host + "\r\n" + "X-MVG-Authorization-Key: 5af1beca494712ed38d313714d4caff6\r\n" + "Connection: close\r\n\r\n");

  while (client.connected()) {
    String line = client.readStringUntil('\n');
    //Serial.println(line);
    if (line == "\r") {
      Serial.println("ende connect");
      break;
    }
  }

  while (client.available()) {

    String line = client.readStringUntil('\r');


    const char* json = line.c_str();


    DynamicJsonBuffer jsonBuffer(bufferSize);
    JsonObject& root = jsonBuffer.parseObject(json, 100);

    if (!root.success()) {
      Serial.println(json);
      Serial.println("JSON parsing failed!");
      break;
    }
    else {
      //    Serial.println(json);
      Serial.println("JSON OK.");
    }

    JsonArray& departures = root["departures"];
    JsonObject& departures0 = departures[0];
    JsonObject& departures1 = departures[1];
    JsonObject& departures2 = departures[2];
    JsonObject& departures3 = departures[3];
    const char* departures0_departureTime = departures0["departureTime"]; // 1492158600000
    const char* departures0_product = departures0["product"]; // "t"
    const char* departures0_label = departures0["label"]; // "27"
    const char* departures0_destination = departures0["destination"]; // "Petuelring"

    const char* departures1_departureTime = departures1["departureTime"]; // 1492158600000
    const char* departures1_product = departures1["product"]; // "t"
    const char* departures1_label = departures1["label"]; // "27"
    const char* departures1_destination = departures1["destination"]; // "Petuelring"

    const char* departures2_departureTime = departures2["departureTime"]; // 1492158600000
    const char* departures2_product = departures2["product"]; // "t"
    const char* departures2_label = departures2["label"]; // "27"
    const char* departures2_destination = departures2["destination"]; // "Petuelring"

    const char* departures3_departureTime = departures3["departureTime"]; // 1492158600000
    const char* departures3_product = departures3["product"]; // "t"
    const char* departures3_label = departures3["label"]; // "27"
    const char* departures3_destination = departures3["destination"]; // "Petuelring"

    timeClient.update();

    String abfahrt0 = String(departures0_departureTime).substring(0, 10);
    String abfahrt1 = String(departures1_departureTime).substring(0, 10);
    String abfahrt2 = String(departures2_departureTime).substring(0, 10);
    String abfahrt3 = String(departures3_departureTime).substring(0, 10);

    uint8_t labfahrt0 = (abfahrt0.toInt() - timeClient.getEpochTime()) / 60;
    uint8_t labfahrt1 = (abfahrt1.toInt() - timeClient.getEpochTime()) / 60;
    uint8_t labfahrt2 = (abfahrt2.toInt() - timeClient.getEpochTime()) / 60;
    uint8_t labfahrt3 = (abfahrt3.toInt() - timeClient.getEpochTime()) / 60;

    if (labfahrt0 > labfahrt1) {
      labfahrt0 = 0;
    }
    if (labfahrt1 > labfahrt2) {
      labfahrt1 = 0;
    }
    if (labfahrt2 > labfahrt3) {
      labfahrt2 = 0;
    }


    abfahrtsmonitor.writeZeile(1, departures0_label, departures0_destination, labfahrt0);
    abfahrtsmonitor.writeZeile(2, departures1_label, departures1_destination, labfahrt1);
    abfahrtsmonitor.writeZeile(3, departures2_label, departures2_destination, labfahrt2);
    abfahrtsmonitor.writeZeile(4, departures3_label, departures3_destination, labfahrt3);

    if (data != 1) {
      abfahrtsmonitor.clear();
    }

    data = 1;

    abfahrtsmonitor.LCDrefresh();

  }
}

